<?php

/////////////////////////////////////////////////////////////////////////////
//  This is a proxy script forwarding Montrada notifications to planyo.com.
/////////////////////////////////////////////////////////////////////////////

function send_http_post($url, $fields, $is_debug) {
  $parts = parse_url($url);
  
  // Make sure we are calling the planyo.com domain.
  $host = $parts['host'];
  if ($host != "www.planyo.com")
    return "";

  if ($is_debug) echo "* url: $url<br />";

  $params = '';
  if ($fields && count($fields) > 0) {
    foreach (array_keys($fields) as $key) {
      $params = $params . "$key=" . rawurlencode($fields[$key]);
      $params .= '&';
    }
  }
  
  $context_options = array(
    'http'=>array(
     'method'=>"POST",
     "Content-length: " . strlen($params) . "\r\n" .
     "Content-type:application/x-www-form-urlencoded\r\n",
     'content'=> $params)
    );

  $context_options['https'] = $context_options['http'];
  $context = @stream_context_create($context_options);
  if (function_exists('curl_init')) {
    $cs = @curl_init($url);
    if ($cs) {
      @curl_setopt ($cs, CURLOPT_POST, 1);
      @curl_setopt ($cs, CURLOPT_POSTFIELDS, $params);
      @curl_setopt ($cs, CURLOPT_FOLLOWLOCATION, 1);
      @curl_setopt ($cs, CURLOPT_RETURNTRANSFER, 1);
      $response = @curl_exec ($cs);
      @curl_close ($cs);
      if ($response && strlen($response) > 0)
        return $response;

      if ($is_debug) echo "* No response returned by curl<br />";
    }
    else {
      if ($is_debug) echo "* unable to initialize curl_init()<br />";
    }
  }
  $fp = @fopen($url, 'r', false, $context);
  $response = '';
  $old_error_reporting = error_reporting();
  error_reporting($is_debug ? E_ALL : $old_error_reporting & ~E_WARNING);
  if ($fp !== false) {
    while (!feof($fp)) {
      $response .= fread($fp, 2048);
    }
  }
  else {
    if ($is_debug) echo "* unable to fopen url<br />";
  }
  fclose($fp);
  error_reporting($old_error_reporting);
  return $response;
}

function is_debug_mode () {
  return $_GET && array_key_exists ("debug_mode", $_GET) && $_GET['debug_mode'] == '1';
}

/////////////////////////////////////
////////////  Main code  ////////////
/////////////////////////////////////

$is_debug = is_debug_mode ();

if ($is_debug)
  echo "### DEBUG MODE ###<br />";

// Collect fields passed by Montrada.
$max_fields_count = 30;
$post_fields = ($_POST && count ($_POST) > $max_fields_count) ? array_slice ($_POST, 0, $max_fields_count) : $_POST;
$get_fields = ($_GET && count ($_GET) > $max_fields_count) ? array_slice ($_GET, 0, $max_fields_count) : $_GET;

$fields = ($post_fields && $get_fields) ? array_merge ($post_fields, $get_fields) : ($get_fields ? $get_fields : $post_fields);

if ($is_debug) {
  if ($fields) {
    echo "fields: ";
    foreach ($fields as $name=>$value) {
      echo "$name=$value,";
    }
    echo "<br />";
  }
}

// Call Montrada processing script on planyo.com
$planyo_script_url = "http://www.planyo.com/payment-montrada-ipn.php";

echo send_http_post ($planyo_script_url, $fields, $is_debug);

?>